# Host

A Host represent a machine with an operating system, be it a physical - bare metal - machine, or a virtual machine.

## Degraded host

If a host is failing due to hardware problems, its category will be set to `Broken`. Our platform will no longer use this host, until its category has been reverted to the original value, e.g. `Dedicated Game Server`, after it is mended. Do not confuse the wording "Dedicated Game Server" with an [application instance](https://docs.i3d.net/game-hosting/elements/application/applicationinstance) (e.g. a deployed Game Server).

## Reserving a Host for a Fleet

See [Reserving a Host for a Fleet](https://docs.i3d.net/game-hosting/deploymentenvironment/fleet#reserving-a-host-for-a-fleet).

## Element structure

| Property             | Value type                                                                  | Required  | Description                                                                                                                                                                                                                                                          |
| -------------------- | --------------------------------------------------------------------------- | --------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| id                   | int                                                                         | Read-only | Unique identifier of this element                                                                                                                                                                                                                                    |
| serverId             | int                                                                         | Read-only | Identifier of the physical or virtual machine (internal Id)                                                                                                                                                                                                          |
| serverName           | string                                                                      | Read-only | Name of the physical or virtual machine (internal name)                                                                                                                                                                                                              |
| isVirtual            | int                                                                         | Read-only | 0) a bare metal machine, 1) a virtual machine                                                                                                                                                                                                                        |
| category             | string                                                                      | Read-only | Host category. Normally "Dedicated Game Servers" or "Dedicated Servers", but can be "Broken" if the server is in a degraded state.                                                                                                                                   |
| locationId           | int                                                                         | Read-only | Legacy location Id (not used for ODP)                                                                                                                                                                                                                                |
| dcLocationId         | int                                                                         | Read-only | Data center location Id. Points to one of /v3/cloud/dcLocation                                                                                                                                                                                                       |
| fleetId              | string                                                                      | Read-only | The ODP fleet ID, if this host has been assigned to a fleet                                                                                                                                                                                                          |
| fleetAssociatedSince | int                                                                         | Read-only | Unix timestamp of the last Fleet association                                                                                                                                                                                                                         |
| dateStart            | string                                                                      | Read-only | The date at which this host was assigned to your account                                                                                                                                                                                                             |
| dateEnd              | string                                                                      | Read-only | The date at which this host will expire                                                                                                                                                                                                                              |
| dateCancelled        | string                                                                      | Read-only | The date at which this host was cancelled                                                                                                                                                                                                                            |
| dateEndContract      | string                                                                      | Read-only | The date at which the contract ends (applicable only if a contract has been signed)                                                                                                                                                                                  |
| contractPeriod       | int                                                                         | Read-only | The contract period in months                                                                                                                                                                                                                                        |
| extendPeriod         | int                                                                         | Read-only | The service extend period in months                                                                                                                                                                                                                                  |
| purchaseOrder        | string                                                                      | Read-only | Purchase order, if one has been supplied via our billing department                                                                                                                                                                                                  |
| paymentTerm          | int                                                                         | Read-only | The payment term in days (how many days are invoices generated before dateEnd)                                                                                                                                                                                       |
| ipAddress            | \[[HostIp](https://docs.i3d.net/game-hosting/elements/host/hostip)]         | Read-only | All IP addresses assigned to this host. Note that the public IP address of a VM is also listed, even though it is assigned via NAT and not actually allocated on the host itself.                                                                                    |
| numCpu               | int                                                                         | Read-only | Number of CPUs in this host                                                                                                                                                                                                                                          |
| cpuInfo              | string                                                                      | Read-only | CPU Type, Family, Model and Stepping information                                                                                                                                                                                                                     |
| cpuType              | string                                                                      | Read-only | CPU type. e.g. "Intel(R) Xeon(R) CPU E3-1230 @ 3.20GHz"                                                                                                                                                                                                              |
| cpuLoad              | int                                                                         | Read-only | CPU load                                                                                                                                                                                                                                                             |
| cpu                  | \[[HostCpu](https://docs.i3d.net/game-hosting/elements/host/hostcpu)]       | Read-only | CPU details                                                                                                                                                                                                                                                          |
| disk                 | \[[HostDisk](https://docs.i3d.net/game-hosting/elements/host/hostdisk)]     | Read-only | Disk drive details                                                                                                                                                                                                                                                   |
| memory               | \[[HostMemory](https://docs.i3d.net/game-hosting/elements/host/hostmemory)] | Read-only | Memory details                                                                                                                                                                                                                                                       |
| isReserve            | int                                                                         | Read-only | Indicates whether this host has been reserved for a fleet. This value can only be 1 if a fleetId is provided as well. You can set this property via [PUT /v3/fleet/{fleetId}/host/{hostId}/reserve](https://docs.i3d.net/api/api_one#v3-fleet-fleetid-host-reserved) |
| labels               | \[[Label](https://docs.i3d.net/game-hosting/elements/application/label)]    | No        | Collection of client-defined labels                                                                                                                                                                                                                                  |
| isODP                | int                                                                         | Read-only | If 1, this host has been assigned for use by the Game Hosting Platform and can be used for game deployment                                                                                                                                                           |

Table 1: Host element structure

## API example

List all your Hosts.

[Full API reference](https://docs.i3d.net/api/api_one#v3-host-summary)

#### HTTP request

[`GET /v3/host`](https://docs.i3d.net/api/api_one#v3-host)

#### Response body

```
[
    {
        "id": 42297,
        "serverId": 16514,
        "serverName": "Server 10309",
        "isVirtual": 0,
        "category": "Dedicated Game Servers",
        "osId": 151,
        "locationId": 18,
        "dcLocationId": 6,
        "fleetId": "0",
        "dateStart": "2016-02-16",
        "dateEnd": "2021-04-01",
        "dateCancelled": "2018-08-07",
        "dateEndContract": "2021-04-01",
        "contractPeriod": 1,
        "extendPeriod": 1,
        "purchaseOrder": "",
        "paymentTerm": 30,
        "ipAddress": [
            {
                "ipAddress": "31.204.131.39",
                "version": 4,
                "type": 1,
                "private": 0
            },
            {
                "ipAddress": "172.16.38.144",
                "version": 4,
                "type": 2,
                "private": 1
            },
            {
                "ipAddress": "2a00:1630:2:1606::",
                "version": 6,
                "type": 1,
                "private": 0
            }
        ],
        "numCpu": 1,
        "cpuInfo": "Type 0, Family 6, Model 42, Stepping 7",
        "cpuType": "Intel(R) Xeon(R) CPU E3-1270 v6 @ 3.80GHz",
        "cpuLoad": 0,
        "disk": [
            {
                "diskType": "ATA Disk",
                "diskMedium": "hdd",
                "model": "Western Digital RE4",
                "product": "WDC WD1003FBYX-18Y7B0",
                "diskSerial": "WD-WCAW32130431",
                "firmwareVersion": "01.01V02",
                "rotationRate": 7200,
                "sectorSizeLogical": 512,
                "sectorSizePhysical": 512,
                "size": 931000000000
            }
        ],
        "memory": [
            {
                "brand": "01980000002C",
                "model": "9965669-033.A00G",
                "size": 17179869184,
                "speed": 2400,
                "ecc": 1,
                "memoryBank": 0,
                "memoryType": "DIMM DDR4 2400 MHz Synchronous, Unbuffered (Unregistered), ECC",
                "memorySlot": "A1",
                "memorySerial": "EE203736"
            },
            {
                "brand": "0198000000AD",
                "model": "9965669-026.A00G",
                "size": 17179869184,
                "speed": 2133,
                "ecc": 1,
                "memoryBank": 1,
                "memoryType": "DIMM DDR4 2133 MHz Synchronous, Unbuffered (Unregistered), ECC",
                "memorySlot": "A2",
                "memorySerial": "E73C5BC0"
            }
        ],
        "isReserve": 0,
        "labels": []
    },
]
```
